//*****************************************************************************
//!
//! @file $Id: OutputEnable.c 804 2008-02-20 09:09:20Z raubree $
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief 啔 : PSCo͂łPWM LEDǐՊ
//!
//! @todo
//! @bug
//*****************************************************************************

//_____ ݸٰ _______________________________________________________________
#include "gcc_compiler.h"
#include <avr/io.h>

#include "pll_drv.h"

#include "psc_drv.h"

//_____ ` __________________________________________________________________

#define A_SA_VAL	25
#define A_RA_VAL	75
#define A_SB_VAL	40

#define B_SA_VAL	110
#define B_RA_VAL	80
#define B_SB_VAL	115

#define C_SA_VAL	60
#define C_RA_VAL	80
#define C_SB_VAL	90

#define RB_VAL		125

/* ȂPSC`Ԑݒɒ`ĂB */
#define PSC_PRESCALER			PSC_NODIV_CLOCK
#define PSC_CLOCK_SOURCE		PSC_CLOCK_SOURCE_EQ_PLL

#define PSC_MODE				PSC_MODE_CENTERED

#define PSC_OUTPUT_B_POLARITY	PSC_OUTPUT_HIGH
#define PSC_OUTPUT_A_POLARITY	PSC_OUTPUT_HIGH

  unsigned char temp;
  unsigned char i;

/*F**************************************************************************
* NAME: PSC
*****************************************************************************/
void PSC_Init (void)
{
  Psc_enable_all_outputs();							// PSCSo͋

  Psc_set_module_A(A_SA_VAL,A_RA_VAL,A_SB_VAL);		// PSC0rl
  Psc_set_module_B(B_SA_VAL,B_RA_VAL,B_SB_VAL);		// PSC1rl
  Psc_set_module_C(C_SA_VAL,C_RA_VAL,C_SB_VAL);		// PSC2rl
  Psc_set_register_RB(RB_VAL);

  Psc_config();										// PSC`Ԑݒ

  Psc_run();										// PSCs
}

/*F**************************************************************************
* NAME: main
*****************************************************************************/
int main (void)
{
  Start_pll_64_mega();						// PLL 64MHzn
  Wait_pll_ready();							// PLLҋ@
  PSC_Init();								// PSC

  while(1)
  {
	temp=1;
	for (i = 1; i < 7; i++)					// 0A0B1A1B2A2B
	{
	  POC = temp;							// Ήo͂̂݋
	  temp = (temp<<1);						// ޯĈʒuړ
	  delay();								// xҋ@
	}
	Psc_select_outputs(0,1,0,1,0,1);		// 2A,1A,0Ao͂̂݋
	delay();								// xҋ@

	Psc_select_outputs(1,0,1,0,1,0);		// 2B,1B,0Bo͂̂݋
	delay();								// xҋ@

	Psc_select_outputs(1,1,0,0,1,1);		// 2B,2A,0B,0Ao͂̂݋
	delay();								// xҋ@

	Psc_select_outputs(0,0,1,1,0,0);		// 1B,1Ao͂̂݋
	delay();								// xҋ@
  }
}
